\name{get.ends}
\alias{get.ends}
\title{ get the ends of each possible segment }
\description{
  get the predicted end point of each possible segment, in order to simplify the calculation of forward and backward probability.
}
\usage{
get.ends(x, p, du, step, b.limit)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{ a vector of observations }
  \item{p}{ a vector of the same length as x, indicating the positions(time) of observations x }
  \item{du}{ duration probability matrix }
  \item{step}{ length of one step }
  \item{b.limit}{ if the segmental model of one segment is linear model with a slope, b.limit is the minimum absolute value of the slope }
}
\details{
}
\value{
  A list:
  \item{end }{a list of predicted value of x at the end point of all the segments at each state}
  \item{idx }{a list of indicators the same size as end, which indicate whether a segment is possible or not}
}
\references{ }
\author{ Wei Sun sunwei@stat.ucla.edu }
\note{ }

\examples{

}
\keyword{ utilities }
